"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("@vue-async/utils");
var hook_1 = __importDefault(require("../utils/hook"));
var globalFilters = hook_1.default.buildPreinitializedHook({});
function hook(tag, functionToAdd, priority, acceptedArgs) {
    if (functionToAdd) {
        if (!(0, utils_1.hasOwn)(globalFilters, tag)) {
            globalFilters[tag] = new hook_1.default();
        }
        globalFilters[tag].addFilter(functionToAdd, priority, acceptedArgs);
    }
    else {
        return {
            has: function (functionToCheck) {
                if (!(0, utils_1.hasOwn)(globalFilters, tag)) {
                    return false;
                }
                return globalFilters[tag].hasFilter(functionToCheck);
            },
            remove: function (functionToRemove, priority) {
                if (priority === void 0) { priority = 10; }
                var removed = false;
                if ((0, utils_1.hasOwn)(globalFilters, tag)) {
                    removed = globalFilters[tag].removeFilter(functionToRemove, priority);
                }
                return removed;
            },
            removeAll: function (priority) {
                if ((0, utils_1.hasOwn)(globalFilters, tag)) {
                    globalFilters[tag].removeAllFilters(priority);
                }
            },
            filter: function (value) {
                var _a;
                var args = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    args[_i - 1] = arguments[_i];
                }
                if ((0, utils_1.hasOwn)(globalFilters, 'all')) {
                    // todo:apply tag "all" filter
                }
                if ((0, utils_1.hasOwn)(globalFilters, tag)) {
                    return (_a = globalFilters[tag]).applyFilters.apply(_a, __spreadArray([value], __read(args), false));
                }
                return Promise.resolve(value);
            },
            exec: function () {
                var _a;
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                if ((0, utils_1.hasOwn)(globalFilters, tag)) {
                    return (_a = globalFilters[tag]).doAction.apply(_a, __spreadArray([], __read(args), false));
                }
                return Promise.resolve();
            },
        };
    }
}
exports.default = hook;
//# sourceMappingURL=hooks.js.map